package com.yihu.quota;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.security.SecurityAutoConfiguration;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
import org.springframework.cloud.netflix.feign.EnableFeignClients;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.data.web.config.EnableSpringDataWebSupport;

/**
 * @author janseny
 * @date 2017/06/16
 */
@Configuration
@ComponentScan(basePackages = {"com.yihu"})
@EnableFeignClients
@EnableDiscoveryClient
@EnableEurekaClient
@EnableSpringDataWebSupport
@EnableJpaRepositories(basePackages = "com.yihu.quota.dao")
@SpringBootApplication(exclude = {SecurityAutoConfiguration.class})
public class SvrQuotaApplication {

    public static void main(String[] args) {
        SpringApplication.run(SvrQuotaApplication.class, args);
    }
}