package com.yihu.quota.etl.formula;

/**
 * @author l4qiang
 */
public class AgeGroupFunc implements Functioner {
    public static final String level_age_1_name = "0~6";
    public static final String level_age_2_name = "7~17";
    public static final String level_age_3_name = "18~40";
    public static final String level_age_4_name = "41~65";
    public static final String level_age_5_name = ">65";
    public static final String level_age_6_name = "其他";

    private static final String level_age_1 = "1";
    private static final String level_age_2 = "2";
    private static final String level_age_3 = "3";
    private static final String level_age_4 = "4";
    private static final String level_age_5 = "5";
    private static final String level_age_6 = "6";
    private static final int AGE_6 = 6;
    private static final int AGE_17 = 17;
    private static final int AGE_40 = 40;
    private static final int AGE_65 = 65;

    @Override
    public String execute(Object... args) {
        if (args.length == 0) {
            return level_age_6;
        }

        int age = (int) args[0];
        if (age <= AGE_6) {
            return level_age_1;
        } else if (age <= AGE_17) {
            return level_age_2;
        } else if (age <= AGE_40) {
            return level_age_3;
        } else if (age <= AGE_65) {
            return level_age_4;
        } else {
            return level_age_5;
        }
    }
}
