package com.yihu.quota.etl.formula;

import java.time.Duration;
import java.time.LocalDate;
import java.time.ZoneId;
import java.util.Date;

/**
 * @author l4qiang
 */
public class DaysFunc implements Functioner {
    @Override
    public Long execute(Object... args) {
        if (args.length < 2) {
            return 0L;
        }

        Date start = (Date) args[0];
        LocalDate startLocalDate = start.toInstant().atZone(ZoneId.systemDefault()).toLocalDate();
        Date end = (Date) args[1];
        LocalDate endLocalDate = end.toInstant().atZone(ZoneId.systemDefault()).toLocalDate();
        Duration duration = Duration.between(endLocalDate, startLocalDate);
        return Math.abs(duration.toDays());
    }
}
