package com.yihu.quota.model.dimension;


import javax.persistence.*;
import java.util.List;

/**
 * 多维数据集维度 entity
 * Created by wxw on 2018/9/7.
 * @author wxw
 */
@Entity
@Table(name = "olap_dimension")
public class Dimension {
    private Integer id;
    /**
     *名称
     */
    private String name;
    /**
     * 编码
     */
    private String code;
    /**
     * 类型 : 1 维度 2 属性 3 指标
     */
    private Integer type;
    /**
     * 数据字典
     */
    private String dict;
    /**
     * 中间算法
     */
    private String algorithm;

    /**
     * 中间算法参数
     */
    private String parm;

    /**
     * 数据类型
     */
    private String dataType;

    /**
     * 临时字段,存放维度成员
     */
    private List<DimensionMember> dimensionMembers;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", unique = true, nullable = false)
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    public String getDict() {
        return dict;
    }

    public void setDict(String dict) {
        this.dict = dict;
    }

    public String getAlgorithm() {
        return algorithm;
    }

    public void setAlgorithm(String algorithm) {
        this.algorithm = algorithm;
    }

    @Column(name = "data_type")
    public String getDataType() {
        return dataType;
    }

    public void setDataType(String dataType) {
        this.dataType = dataType;
    }

    public String getParm() {
        return parm;
    }

    public void setParm(String parm) {
        this.parm = parm;
    }

    @Transient
    public List<DimensionMember> getDimensionMembers() {
        return dimensionMembers;
    }

    public void setDimensionMembers(List<DimensionMember> dimensionMembers) {
        this.dimensionMembers = dimensionMembers;
    }
}
