package com.yihu.quota.model.source;

import org.hibernate.annotations.Formula;

import javax.persistence.*;

/**
 * Created by wxw on 2018/9/10.
 *
 * @author wxw.
 */
@Entity
@Table(name = "olap_data_sources_table_field")
public class DataSourcesTableField {
    private Integer id;
    /**
     * 表名Id
     */
    private Integer tableId;
    /**
     * 字段名
     */
    private String fieldName;

    /**
     * 字段编码
     */
    private String fieldCode;
    /**
     * 字段类型
     */
    private String fieldType;
    /**
     * 备注
     */
    private String note;

    /**
     * 临时字段，字段所在表的名称
     */
    private String tableName;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", unique = true, nullable = false)
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    @Column(name = "table_id")
    public Integer getTableId() {
        return tableId;
    }

    public void setTableId(Integer tableId) {
        this.tableId = tableId;
    }

    @Column(name = "field_name")
    public String getFieldName() {
        return fieldName;
    }

    public void setFieldName(String fieldName) {
        this.fieldName = fieldName;
    }


    @Column(name = "field_code")
    public String getFieldCode() {
        return fieldCode;
    }

    public void setFieldCode(String fieldCode) {
        this.fieldCode = fieldCode;
    }

    @Column(name = "field_type")
    public String getFieldType() {
        return fieldType;
    }

    public void setFieldType(String fieldType) {
        this.fieldType = fieldType;
    }

    public String getNote() {
        return note;
    }

    public void setNote(String note) {
        this.note = note;
    }

    @Formula("(SELECT tables.table_name FROM olap_data_sources_table_field filed Right JOIN olap_data_sources_table tables ON filed.table_id = tables.id WHERE filed.id  = id)")
    public String getTableName() {
        return tableName;
    }

    public void setTableName(String tableName) {
        this.tableName = tableName;
    }
}
