package com.yihu.quota.model.view;


import com.yihu.ehr.entity.BaseAssignedEntity;
import com.yihu.ehr.entity.BaseIdentityEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * 视图维度 entity
 *
 * @author janseny
 * @date 2018年9月26日
 */
@Entity
@Table(name = "olap_view_dimension")
public class ViewDimension extends BaseAssignedEntity {

    private String viewId; // 视图Id
    private String dimensionCode; // 维度编码
    private String dimensionName; // 维度名称
    private String cubeCode; // 多维度数据集编码
    private String esIndex; // 多维数据集的 ES index
    private String esType; //  多维数据集的 ES type
    private String dimensionType; // 维度类型，row：行维度，col：列维度，drill：钻取维度，默认行维度。
    private Integer groupRow; // 行维度组
    private Integer groupRowOrder; // 组内行维度顺序
    private Integer columnDrillOrder; // 列维度/钻取维度的顺序
    private String memberOrderType; // 行/列维度成员排序方式，name：按名称排序，sub_agg：按子聚合统计值排序。
    private String memberOrderStrategy; // 行/列维度成员排序策略，asc：升序，desc：降序。
    private String memberOrderQuotaId; // 行/列维度成员按子聚合排序的指标ID。
    private Integer memberCount; // 行/列维度成员返回个数
    private String memberDateFormat; // 行/列维度成员日期格式
    private String memberDateInterval; // 行/列维度成员日期间隔

    @Column(name = "view_id")
    public String getViewId() {
        return viewId;
    }

    public void setViewId(String viewId) {
        this.viewId = viewId;
    }

    @Column(name = "dimension_code")
    public String getDimensionCode() {
        return dimensionCode;
    }

    public void setDimensionCode(String dimensionCode) {
        this.dimensionCode = dimensionCode;
    }

    @Column(name = "dimension_name")
    public String getDimensionName() {
        return dimensionName;
    }

    public void setDimensionName(String dimensionName) {
        this.dimensionName = dimensionName;
    }

    @Column(name = "cube_code")
    public String getCubeCode() {
        return cubeCode;
    }

    public void setCubeCode(String cubeCode) {
        this.cubeCode = cubeCode;
    }

    @Column(name = "es_index")
    public String getEsIndex() {
        return esIndex;
    }

    public void setEsIndex(String esIndex) {
        this.esIndex = esIndex;
    }

    @Column(name = "es_type")
    public String getEsType() {
        return esType;
    }

    public void setEsType(String esType) {
        this.esType = esType;
    }

    @Column(name = "dimension_type")
    public String getDimensionType() {
        return dimensionType;
    }

    public void setDimensionType(String dimensionType) {
        this.dimensionType = dimensionType;
    }

    @Column(name = "group_row")
    public Integer getGroupRow() {
        return groupRow;
    }

    public void setGroupRow(Integer groupRow) {
        this.groupRow = groupRow;
    }

    @Column(name = "group_row_order")
    public Integer getGroupRowOrder() {
        return groupRowOrder;
    }

    public void setGroupRowOrder(Integer groupRowOrder) {
        this.groupRowOrder = groupRowOrder;
    }

    @Column(name = "column_drill_order")
    public Integer getColumnDrillOrder() {
        return columnDrillOrder;
    }

    public void setColumnDrillOrder(Integer columnDrillOrder) {
        this.columnDrillOrder = columnDrillOrder;
    }

    @Column(name = "member_order_type")
    public String getMemberOrderType() {
        return memberOrderType;
    }

    public void setMemberOrderType(String memberOrderType) {
        this.memberOrderType = memberOrderType;
    }

    @Column(name = "member_order_strategy")
    public String getMemberOrderStrategy() {
        return memberOrderStrategy;
    }

    public void setMemberOrderStrategy(String memberOrderStrategy) {
        this.memberOrderStrategy = memberOrderStrategy;
    }

    @Column(name = "member_order_quota_id")
    public String getMemberOrderQuotaId() {
        return memberOrderQuotaId;
    }

    public void setMemberOrderQuotaId(String memberOrderQuotaId) {
        this.memberOrderQuotaId = memberOrderQuotaId;
    }

    @Column(name = "member_count")
    public Integer getMemberCount() {
        return memberCount;
    }

    public void setMemberCount(Integer memberCount) {
        this.memberCount = memberCount;
    }

    @Column(name = "member_date_format")
    public String getMemberDateFormat() {
        return memberDateFormat;
    }

    public void setMemberDateFormat(String memberDateFormat) {
        this.memberDateFormat = memberDateFormat;
    }

    @Column(name = "member_date_interval")
    public String getMemberDateInterval() {
        return memberDateInterval;
    }

    public void setMemberDateInterval(String memberDateInterval) {
        this.memberDateInterval = memberDateInterval;
    }
}
