package com.yihu.quota.service.dimension;

import com.yihu.ehr.query.BaseJpaService;
import com.yihu.quota.dao.dimension.DimensionDao;
import com.yihu.quota.dao.dimension.DimensionMemberDao;
import com.yihu.quota.model.dimension.Dimension;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;


/**
 * Created by wxw on 2018/9/7.
 * @author wxw
 */
@Service
public class DimensionService extends BaseJpaService<Dimension, DimensionDao> {

    @Autowired
    private DimensionDao dimensionDao;
    @Autowired
    private DimensionMemberDao dimensionMemberDao;

    /**
     * 保存接口
     * @param dimension
     * @return 保存之后的id
     */
    public Integer saveDimension(Dimension dimension) {
        dimension = dimensionDao.save(dimension);
        return dimension.getId();
    }

    public void deleteDimension(Integer id) {
        dimensionDao.delete(id);
        // 同时删掉隶属于该维度的成员
        dimensionMemberDao.deleteByDimensionId(id);
    }

}
